//
//  ACInstallationReportWindowController.m
//  PackageWrapper
//
//  Created by stephane on 01/05/2020.
//  Copyright © 2020 Acme, inc. All rights reserved.
//

#import "ACInstallationReportWindowController.h"

NSString * const ACDistributionFileName=@"RealPackage";

@interface ACInstallationReportWindowController ()
{
    IBOutlet NSTextField * _label;
    
    IBOutlet NSProgressIndicator * _progressIndicator;
}

@end

@implementation ACInstallationReportWindowController

- (NSString *)windowNibName
{
    return @"ACInstallationReportWindowController";
}

- (void)awakeFromNib
{
    _label.stringValue=[NSString stringWithFormat:NSLocalizedString(@"Installing %@...",@""),ACDistributionFileName];
    
    [_progressIndicator startAnimation:self];
}

#pragma mark -

- (void)performInstallation
{
    [self showWindow:self];
    
    NSTask * tTask=[NSTask new];
    tTask.launchPath=@"/usr/sbin/installer";
    tTask.arguments=@[
                      @"-pkg",
                      [[NSBundle mainBundle] pathForResource:ACDistributionFileName ofType:@"pkg"],
                      @"-target",
                      @"CurrentUserHomeDirectory"
                      ];
    
    tTask.terminationHandler=^(NSTask * bTask){
    
        dispatch_async(dispatch_get_main_queue(), ^{
           
            [self->_progressIndicator stopAnimation:self];
            
            [NSApp terminate:self];
            
        });
    };
    
    [tTask launch];
}

#pragma mark -

- (IBAction)showWindow:(id)sender
{
    [self.window center];
    
    [super showWindow:sender];
}

@end
