//
//  InstallationReportWindowController.swift
//  app_wrapper
//
//  Created by stephane on 01/05/2020.
//  Copyright © 2020 Acme, inc. All rights reserved.
//

import Cocoa

let distributionFileName = "RealPackage"

class InstallationReportWindowController: NSWindowController
{
    @IBOutlet var _label: NSTextField!
    
    @IBOutlet var _progressIndicator: NSProgressIndicator!
    
    override var windowNibName: String!
    {
        return "InstallationReportWindowController"
    }
    
    override func windowDidLoad()
    {
        super.windowDidLoad()
        
        _label.stringValue=NSString.localizedStringWithFormat("Installing %@", distributionFileName) as String
        
        _progressIndicator.startAnimation(self)
    }
    
    override func showWindow(_ sender: Any?)
    {
        if let window = self.window
        {
            window.center()
        }
        
        super.showWindow(sender)
    }
    
    func performInstallation()
    {
        self.showWindow(self)
        
        let tProcess=Process()
        
        tProcess.executableURL=NSURL.fileURL(withPath: "/usr/sbin/installer")
        tProcess.arguments=[
                            "-pkg",
                            Bundle.main.path(forResource: distributionFileName, ofType: "pkg")!,
                            "-target",
                            "CurrentUserHomeDirectory"
                            ]
        
        tProcess.terminationHandler={ (bProcess) in
            
            DispatchQueue.main.async {
                
                self._progressIndicator.stopAnimation(self)
                
                NSApp.terminate(self)
                
            }
        }
        
        tProcess.launch()
    }
}
